//  -*- Mode: C++ -*-
//////////////////////////////////////////////////////////////////////////////
//
//  $Id: extern.cc,v 3.1 1996/02/16 18:23:00 jaeho Exp $
//  $Source: /afs/engin.umich.edu/u/j/a/jaeho/UM-PRS/code3.1/RCS/extern.cc,v $
//
//  File	      : extern.cc
//  Author(s)	      : Jaeho Lee <jaeho@clippers.engin.umich.edu>
//
//  Description	      : External variables and classes
//
//  Original author(s): Jaeho Lee <jaeho@clippers.engin.umich.edu>
//  Organization      : Distributed Intelligent Agents Group (UM-DIAG)
//  Created On	      : Wed Mar 30 11:18:16 1994
//  Last Modified By  : Marc Huber <marcush@darwin>
//  Last Modified On  : Mon Apr 22 14:58:34 1996
//  Update Count      : 73
//
//////////////////////////////////////////////////////////////////////////////
//
//  UM-PRS
//
//  Copyright 1996
//  The Regents of the University of Michigan
//  All Rights Reserved
//  All Rights Reserved
//
//  This software is provided as is, without representation as to its
//  fitness for any purpose, and without warranty of any kind, either
//  express or implied, including without limitation the implied
//  warranties of merchantability and fitness for a particular purpose.
//  The Regents of the University of Michigan shall not be liable for any
//  damages, including special, indirect, incidental, or consequential
//  damages, with respect to any claim arising out of or in connection
//  with the use of the software, even if it has been or is hereafter
//  advised of the possibility of such damages.
//
//	    This work has been sponsored in part by:
//    the Department of Defense Advanced Research Projects Agency
//		 under grant DAAE-07-92-C-R012.
//
//////////////////////////////////////////////////////////////////////////////

#include <stream.h>
#include <stdlib.h>

#include "extern.h"
#include "symtab.h"
#include "wm.h"
#include "goal.h"

//////////////////////////////////////////////////////////////////////
/////								 /////
/////			Global Variables			 /////
/////								 /////
//////////////////////////////////////////////////////////////////////

Program program;
Parser	parser;

//
//
//

Program::~Program()
{
  delete ka_library;
  delete world_model;
  delete goal_list;
  delete is;
  delete cycle;
}

Program::Program()
{
  ka_library	= new KaTable;
  world_model	= new WmTable;
  goal_list	= new GoalSet;
  is		= new IntentionStructure;
  cycle		= 0;
  
  show_wm 	= 0;
  show_gl 	= 0;
  show_is 	= 0;
  show_soak	= 0;

  sim_mode	= 0;
  
  priority_evaluation_function_hook = 0;
}

//
//
//

void Parser::reset(char* file_name)
{
  source_file_name = file_name;
  source_line_number = 1;
  source_char_position = 0;
  nest_level = 0;
  level_section = 0;
  level_expression = 0;
  error_count = 0;
}

void Parser::stop_on_too_many_errors()
{
  if (++error_count > error_limit) {
    cerr << "\n*** Too many errors. Exit ***\n";
    exit(1);
  }
}

void Parser::stop_if_errors()
{
  if (error_count > 0) {
    cerr << "\n*** Parsing error. Exit ***\n";
    exit(1);
  }
}


