//  -*- Mode: C++ -*-
//////////////////////////////////////////////////////////////////////////////
//  
//  $Id: extern.h,v 3.1 1996/02/16 18:23:00 jaeho Exp $
//  $Source: /afs/engin.umich.edu/u/j/a/jaeho/UM-PRS/code3.1/RCS/extern.h,v $
//  
//  File	      : extern.h
//  Author(s)	      : Jaeho Lee <jaeho@engin.umich.edu>
//  
//  Description	      : external variables or global definitions
//  
//  Original author(s): Jaeho Lee <jaeho@engin.umich.edu>
//  Organization      : Distributed Intelligent Agents Group (UM-DIAG)
//  Created On	      : Sat Jul	 3 12:31:48 1993
//  Last Modified By  : Marc Huber <marcush@darwin>
//  Last Modified On  : Fri Apr 19 18:05:51 1996
//  Update Count      : 89
//  
//////////////////////////////////////////////////////////////////////////////
//
//  UM-PRS
//
//  Copyright 1996
//  The Regents of the University of Michigan
//  All Rights Reserved
//
//  This software is provided as is, without representation as to its
//  fitness for any purpose, and without warranty of any kind, either
//  express or implied, including without limitation the implied
//  warranties of merchantability and fitness for a particular purpose.
//  The Regents of the University of Michigan shall not be liable for any
//  damages, including special, indirect, incidental, or consequential
//  damages, with respect to any claim arising out of or in connection
//  with the use of the software, even if it has been or is hereafter
//  advised of the possibility of such damages.
// 
//	    This work has been sponsored in part by:
//    the Department of Defense Advanced Research Projects Agency
//		 under grant DAAE-07-92-C-R012.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __EXTERN_H__
#define __EXTERN_H__

#define UM_PRS

//////////////////////////////////////////////////////////////////////
/////								 /////
/////			Global Variables			 /////
/////								 /////
//////////////////////////////////////////////////////////////////////

extern class Program program;
extern class Parser  parser;

//
//
//

class Program
{
public:
  class KaTable*		ka_library;
  class WmTable*		world_model;
  class GoalSet*		goal_list;
  class IntentionStructure*	is;
  class Ka*			cycle;

  int	show_wm;
  int	show_gl;
  int	show_is;
  int	show_soak;

  int	sim_mode;
  
  double (*priority_evaluation_function_hook)(double goal_priority, double ka_priority);
  
  //
  
  ~Program();
  Program();
};

//

class Parser
{
public:
  char* source_file_name;
  long	source_line_number;
  long	source_char_position;
  long	nest_level;
	
  long	level_section;
  long	level_expression;
	
  long	error_count;
  long	error_limit;

  //

  void reset(char* file_name=0);

  void stop_on_too_many_errors();
  void stop_if_errors();

  Parser(char* file_name=0)
  {
    reset(file_name);
    error_limit = 10;
  }
};

#endif


