//  -*- Mode: C++ -*-
//////////////////////////////////////////////////////////////////////////////
//  
//  $Id$
//  $Source$
//  
//  File              : interpreter.h
//  Author(s)         : Marc Huber <marcush@darwin>
//  
//  Description       : 
//  
//  Original author(s): Marc Huber <marcush@darwin>
//  Organization      : ORINCON Corporation
//  Created On        : Fri Apr 19 15:09:53 1996
//  Last Modified By  : Marcus J. Huber <marcush@ultra>
//  Last Modified On  : Fri Feb 21 14:16:54 1997
//  Update Count      : 7
//  
//  Copyright (C) 1996 ORINCON Corporation.
//  
//  PURPOSE
//  	|>Description of module's purpose<|
//  
//////////////////////////////////////////////////////////////////////////////
//
//  UM-PRS
//
//  Copyright 1996
//  The Regents of the University of Michigan
//  All Rights Reserved
//
//  This software is provided as is, without representation as to its
//  fitness for any purpose, and without warranty of any kind, either
//  express or implied, including without limitation the implied
//  warranties of merchantability and fitness for a particular purpose.
//  The Regents of the University of Michigan shall not be liable for any
//  damages, including special, indirect, incidental, or consequential
//  damages, with respect to any claim arising out of or in connection
//  with the use of the software, even if it has been or is hereafter
//  advised of the possibility of such damages.
// 
//	    This work has been sponsored in part by:
//    the Department of Defense Advanced Research Projects Agency
//		 under grant DAAE-07-92-C-R012.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __INTERPRETER_H__
#define __INTERPRETER_H__

#include "extern.h"

class KaTable;
class WmTable;
class GoalSet;
class IntentionStructure;

class Interpreter {

public:
  int	interprete(KaTable* ka_library, WmTable* world_model,
		   GoalSet* goal_list, IntentionStructure* is);

  KaTable*		get_ka_library()		{ return program.ka_library; }
  WmTable*		get_world_model()		{ return program.world_model; }
  GoalSet*		get_goal_list() 		{ return program.goal_list; }
  IntentionStructure*	get_intention_structure()	{ return program.is; }
};

#endif
