//  -*- Mode: C++ -*-
//////////////////////////////////////////////////////////////////////////////
//  
//  $Id: parse.cc,v 3.1.1.1 1996/02/27 06:48:39 jaeho Exp $
//  $Source: /afs/engin.umich.edu/u/j/a/jaeho/UM-PRS/code3.1/RCS/parse.cc,v $
//  
//  File	      : parse.cc
//  Author(s)	      : Jaeho Lee <jaeho@hotpink.engin.umich.edu>
//  
//  Description	      : 
//  
//  Original author(s): Jaeho Lee <jaeho@hotpink.engin.umich.edu>
//  Organization      : Distributed Intelligent Agents Group (UM-DIAG)
//  Created On	      : Wed Feb 22 15:55:12 1995
//  Last Modified By  : Jaeho Lee <jaeho@splat.engin.umich.edu>
//  Last Modified On  : Mon Feb 26 23:53:51 1996
//  Update Count      : 37
//  
//////////////////////////////////////////////////////////////////////////////
//
//  UM-PRS
//
//  Copyright 1996
//  The Regents of the University of Michigan
//  All Rights Reserved
//
//  This software is provided as is, without representation as to its
//  fitness for any purpose, and without warranty of any kind, either
//  express or implied, including without limitation the implied
//  warranties of merchantability and fitness for a particular purpose.
//  The Regents of the University of Michigan shall not be liable for any
//  damages, including special, indirect, incidental, or consequential
//  damages, with respect to any claim arising out of or in connection
//  with the use of the software, even if it has been or is hereafter
//  advised of the possibility of such damages.
// 
//	    This work has been sponsored in part by:
//    the Department of Defense Advanced Research Projects Agency
//		 under grant DAAE-07-92-C-R012.
//
//////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include <strstream.h>

#include "extern.h"
#include "parse.h"

//
//
//
static istrstream* lex_string_stream = 0;

int lex_getchar()
{
  char c;
  
  if (lex_string_stream) {
    lex_string_stream->get(c);
    return lex_string_stream->eof() ? EOF : c;
  }
  else
    return getc(yyin);
}

//
//
//

long parse(long count, char** file_names)
{
  long error_count = 0;
  
  if (count == 0) {
    error_count += parse(0);
  }
  else {
    for(int i = 0; i < count; i++)
      error_count += parse(file_names[i]);
  }

  return error_count;
}

long parse(char* file_name)
{
  // parses the file and returns the number of errors encountered in the file
  // returns 1 if the file cannot be opened
  
  parser.reset(file_name);
  
  if (!file_name)
    yyin = stdin;
  else
    if ((yyin = fopen(file_name, "r")) == 0) {
      cerr << "*** Can't open " << file_name << " ***\n";
      return 1;
    }

  yyparse();

  fclose(yyin);

  return parser.error_count;
}

long parse_string(char* string)
{
  parser.reset("_string_input_");

  lex_string_stream = new istrstream(string, ::strlen(string));

  yyparse();

  delete lex_string_stream;
  lex_string_stream = 0;

  return parser.error_count;
}

