//  -*- Mode: C++ -*-
//////////////////////////////////////////////////////////////////////////////
//  
//  $Id: um-prs.h,v 3.1 1996/02/16 18:23:00 jaeho Exp $
//  $Source: /afs/engin.umich.edu/u/j/a/jaeho/UM-PRS/code3.1/RCS/um-prs.h,v $
//  
//  File	      : um-prs.h
//  Author(s)	      : Marcus J. Huber <marcush@engin.umich.edu>
//  
//  Description	      : Main program
//  
//  Original author(s): Marcus J. Huber <marcush@engin.umich.edu>
//  Organization      : Distributed Intelligent Agents Group (UM-DIAG)
//  Created On	      : Sat Jul	 3 12:41:39 1993
//  Last Modified By  : Marcus J. Huber <marcush@ultra>
//  Last Modified On  : Fri Feb 21 14:24:47 1997
//  Update Count      : 36
//  
//////////////////////////////////////////////////////////////////////////////
//
//  UM-PRS
//
//  Copyright 1996
//  The Regents of the University of Michigan
//  All Rights Reserved
//
//  This software is provided as is, without representation as to its
//  fitness for any purpose, and without warranty of any kind, either
//  express or implied, including without limitation the implied
//  warranties of merchantability and fitness for a particular purpose.
//  The Regents of the University of Michigan shall not be liable for any
//  damages, including special, indirect, incidental, or consequential
//  damages, with respect to any claim arising out of or in connection
//  with the use of the software, even if it has been or is hereafter
//  advised of the possibility of such damages.
// 
//	    This work has been sponsored in part by:
//    the Department of Defense Advanced Research Projects Agency
//		 under grant DAAE-07-92-C-R012.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __UM_PRS__
#define __UM_PRS__

#include <stream.h>
//#include <time.h>
#include <stdlib.h>
//#include <stdio.h>

#include "interpreter.h"
#include "um-prs.h"
#include "parse.h"

//#include "extern.h"
//#include "exp.h"
//#include "exp-var.h"
//#include "ka.h"
//#include "is.h"
//#include "wm.h"
//#include "soak.h"
//#include "goal.h"

//#include "primitive.h"
//#include "relation.h"

class UMPRS {

public:

  int run(int argc, char* argv[]) {
    cout << "\n\nUM-PRS 3.2\n";
    cout << "Copyright 1996\n";
    cout << "The Regents of the University of Michigan\n";
    cout << "All Rights Reserved\n\n";
    
    yydebug = 0;
    
    Interpreter		interpreter;
    
    while ((--argc > 0) && ((*++argv)[0] == '-')) {
      switch(argv[0][1]) {
      case 'p':
	parser.error_limit = atol(argv[1]);
	--argc;
	++argv;
	cerr << "*** parsing error limit set to " << parser.error_limit << "***\n";
	break;
      case 'g':
	program.show_gl = 1;
	cerr << "*** showing the goal list on ***\n";
	break;
      case 'i':
	program.show_is = 1;
	cerr << "*** showing the intention structure on ***\n";
	break;
      case 's':
	program.show_soak = 1;
	cerr << "*** showing SOAK generation on ***\n";
	break;
      case 'w':
	program.show_wm = 1;
	cerr << "*** showing the world model on ***\n";
	break;
      case 'y': 
	yydebug = 1;
	cerr << "*** yyparse debugging on ***\n";
	break;
      case 'S':
	program.sim_mode = 1;
	break;
      default:  
	cerr << "*** Ignoring unknown flag '" << argv[0][1] << "' ***\n";
	break;
      }
    }
    
    if (parse(argc, argv))
      exit(1);
    
    if (program.sim_mode)
      cerr << "\n*** Running in SIMULATION mode! ***\n";
    
    return interpreter.interprete(program.ka_library, program.world_model,
				  program.goal_list, program.is);
  }
};

#endif
